Introduction

UltraSearch - Introduction

Navigation: »No topics above this level«

UltraSearch - Introduction

UltraSearch searches files and folders on local NTFS drives and provides the results within just a few seconds.

UltraSearch achieves its speed by its innovative usage of the MFT (Master File Table) of NTFS partitions. No permanent index stored on your hard disks is required: UltraSearch uses only the system memory for indexing. The flexible search tool will even identify NTFS hardlinks.

You can enter a file name, a pattern like *.EXE or a regular expression and you will see the results within seconds. Searching for file types like 'Office Files' as well as searching for file content are supported. Additional file information like file size, file dates, or file attributes can be displayed.

Folders, files, or file types can be excluded from the search. The search results can be sorted according to different criteria, printed, or exported as Excel, Text, CSV, HTML or RTF file.

Recently used search patterns can be saved and selected from a drop-down list. UltraSearch can be started from the context menu of your Windows Explorer - starting a search within the selected folder could not be easier. The result list of UltraSearch also provides a context menu which supports known file operations like the 'Open', 'Copy' or 'Move' operation.

Use UltraSearch wherever you like thanks to the portable ZIP version.


Installation

Installation

To install UltraSearch, execute the setup file and follow the instructions. All operating systems from Windows Vista upwards to Windows 10 are supported, including the 64Bit editions. The setup program will copy the necessary files to your hard disk and will create a new program group in the Start menu/screen. UltraSearch can be uninstalled using the Software applet in the Windows Control Panel.

Portable installation

In addition to the normal installer, UltraSearch is available as a ZIP file, which saves its settings locally and can e.g. be run from a portable medium such as an USB stick.


Quickstart

Quickstart

After the installation, UltraSearch can be started using the Windows Start menu/screen, the Desktop shortcut or the context menu of a folder or drive.

The most important elements of the UltraSearch main window will now be explained:

1.Menu bar: The menu bar provides the basic functionality of UltraSearch. Further information can be found here.

2.Search field: The search field is used to enter a search pattern for searching file and folder names. Further information can be found here.

3.File type selection: This field can be used to limit the search to specific file groups or file extensions. Further information can be found here.

4.File content search: The file content search field provides the possibility to search for files that have a specific textual content. Further information can be found here.

5.Options Toolbar: The options toolbar provides the most important search options.

6.Drive list: The drive list shows the currently selected drives and paths that will be used as starting point for the search. By clicking the dropdown button or the panel itself, the full drive list will be opened. This allows you to select or deselect additional search paths.

7.Search result list: The search result list lists all search results which match the specified search pattern. A context menu can be opened via right-clicking in the header to select which columns shall be displayed.

8.Status bar: The status bar provides information about the number of search results and provides additional information about the selected items. It also indicates whether the exclude filter is active.


What's new ?

What's new ?

Version 2.2 : (06 Nov 2018)

New Features

·The file content is now displayed in a preview window on the right.

·Paths and drives can now be pinned to the drive list.

·A new button to stop the current search has been added.

·The language can now be changed via the user interface at "View> Language".

·The user interface now offers a "Delete" button which can be used to remove all entered search criteria.

·An option to use regular expressions has been added.

·The option "Ignore Umlauts/Accents" lets you specify whether umlauts and accents shall be included in the search.

·A new option lets you decide whether to include results in subfolders or not.

·The search history can now be deleted.

·The font size of the result list can now be set in the options.

·An option to select all drives has been added to the context menu of the drive list.

·The user will now be notified via a notification windows when the current search is complete.

·Bitlocker encrypted drives are now supported.

·The TreeSize file search can now be started via "Advanced Search" (if installed).

Improvements

·The enumeration of the Master File Table (MFT) has been accelerated.

·The drive list has been revised. Drives can be selected or deselected faster via additional checkboxes.

·In many cases the search results are already displayed while the MFT is being read.

·If the option "Start with Windows" is activated the user account control is no longer displayed when UltraSearch is started

·Windows XP and Windows Server 2003 are no longer supported.

Bugfixes

·The message "Network drives not are supported" was displayed incorrectly in some cases.

·Sorting the "File Version" column now works correctly.

·The drive information in the drive list was not updated correctly. This issue has been resolved.

·An error during the update or uninstallation while the application was running has been fixed.

·Further small bugfixes and improvements.

Version 2.1.2 : (19 Jul 2016)

·The drive list can also be expanded via right-click now.

·Bugfix: It is now easier to see that the drive list can be expanded.

·Bugfix: Searches on virtual hard disks resulted in an error in some cases. This problem has been solved.

·Bugfix: A minor problem occurring when minimizing UltraSearch to the system tray via shortcut has been fixed.

·Bugfix: Numerous other bugfixes have been implemented.

Version 2.1.1 : (01 Jul 2016)

·Bugfix: An error occurring while starting UltraSearch has been fixed.

·Bugfix: The option 'Always sort results' was not recognized after a program restart. This problem has been solved.

·Bugfix: In some cases starting UltraSearch via command line parameters yielded wrong results. This issue has been fixed.

·Bugfix: The values of the 'File version' column were not calculated until a row was selected. This error has been resolved.

·Bugfix: Some settings were reverted during a program update. This is no longer the case.

·The icons of the exclude filter and the file groups have been updated.

Version 2.1 : (20 Jun 2016)

·UltraSearch now supports searching for file content.

·The drive list has been completely redesigned. It has been moved from the bottom of the result list to its top.

·Use the new drive list to search in single folders or entire drives.

·The new 'File type selection' enables the user to search for specific file groups or file types (e.g. 'Office Files', 'Video Files'). The file groups can be configured via 'Search > File Groups...'.

·UltraSearch now supports command line parameters, which can be used to start UltraSearch with specific search parameters.

·The icons have been revised to fit the style of Windows 10.

·The search results are now displayed even faster.

·The option 'Autocomplete Patterns' has been replaced by the option 'Suggest Patterns'. This option displays a dropdown list beneath the search field containing one or more suggested patterns based on the recently used search patterns.

·The automatic update of the MFT-Index in the systems RAM can now be deactivated via 'Options > Include file system changes'.

·A progress dialog is now displayed during the export of large result lists.

·A new menu entry with information about an advanced search with TreeSize (search network drives, search for duplicate files and much more) has been added.

·The menu entry 'Options Toolbar' has been renamed to 'Toolbars'. The submenu entry 'Show' is now called 'Options Toolbar'.

·The advertising banner has been removed.

·Bugfix: A bug concerning the sorting order of search results during a search has been fixed.

·Bugfix: If the option 'Skip User Account Control Warning' was activated and the program had been renamed or moved to another folder, UltraSearch did not start. This bug has been fixed.

·Bugfix: Searching for file paths ending with a dot produced wrong results. This problem has been resolved.

·Bugfix: In some cases the exclude filter excluded the wrong files. This issue has been fixed.

·Bugfix: The preview of the excluded files in the exclude filter now also displays the exclusion of hidden files.

·Bugfix: Numerous other bugfixes and improvements have been implemented.

Version 2.0.3 : (23 Mar 2015)

·The search speed has been increased for specific search patterns.

·The file author is now set when exporting the search results to an Excel file.

·Bugfix: UltraSearch crashed occasionally when a removable drive was removed. This error has been fixed.

·Bugfix: An error occurring while reading the MFT (Master File Table) on some drives has been fixed.

·Bugfix: The progress bar was not displayed in some cases. This issue has been fixed.

·Bugfix: Numerous other bugfixes have been implemented.

Version 2.0.2 : (02 Mar 2015)

·Added support for hard drives with a sector size of 4K.

·Bugfix: Numerous other bugfixes have been implemented.

Version 2.0.1 : (12 Feb 2015)

·When opening a file or folder via 'Open Containing Folder' the file selected in UltraSearch will also be selected in the Windows Explorer.

·Bugfix: An error occurring while reading the MFT (Master File Table) on some drives has been fixed.

·Bugfix: File system changes caused errors in some cases. This issue has been fixed.

·Bugfix: Numerous other bugfixes have been implemented.

Version 2.0 : (18 Dec 2014)

·A completely redesigned scanning mechanism for reading the MFT (Master File Table) has been implemented.

·A new search algorithm for faster searches has been implemented.

·The memory usage has been greatly reduced.

·The speed of sorting the search results has been greatly increased.

·The new scanning mechanism now always detects NTFS hardlinks. The option to enable/disable NTFS hardlinks has been removed.

·A new options toolbar has been added, enabling the user to quickly switch between file search and folder search and to de-/activate the exclude filter.

·A new button was added next to the search input field, enabling the user to browse for a folder to search in.

·An option to hide and reset the options toolbar was added.

·The 'Auto Sort' option was renamed to 'Always Sort Results'.

·The option 'Always Sort Results' will now be taken into account even after a restart of UltraSearch.

·Pressing the F3 key now focuses the search pattern and allows the user to instantly enter a new search pattern.

·The order of columns in the drive list can now be changed via Drag&Drop.

·Scrolling through the recently used search patterns has been disabled.

·The number of recently used search patterns has been limited to 15.

·Icons have been added to the menus.

·Bugfix: Refreshing the search during an ongoing search causes missing search results in some cases. This bug has been fixed.

·Bugfix: When starting UltraSearch via context menu the search input field is now selected correctly so that the user can immediately specify a search pattern.

·Bugfix: The option 'Autocomplete Patterns' now works properly.

·Bugfix: Disabled columns are now memorized after a restart of UltraSearch.

·Bugfix: File system changes are now detected corretly.

·Bugfix: A bug which caused UltraSearch to crash during a search in rare cases has been fixed.

·Bugfix: Numerous other enhancements and bugfixes have been incorporated.

Version 1.8.1 : (07 Oct 2013)

·Fixed 'Duplicates are not allowed' error on UltraSearch startup.

·Fixed access violations during search.

·Fixed 'Cannot focus disabled or invisible window' error when opening the exclude filter.

·When UltraSearch was started via the context menu, an additional blank was added to the search pattern erroneously. This is no longer the case.

·The advert banner is no longer displayed, if TreeSize Professional or Personal is installed.

·The settings of the portable version are now saved correctly.

·Bugfix: Numerous other bugfixes have been implemented.

Version 1.8 : (06 Aug 2013)

·64bit: UltraSearch is now also available as a native 64-bit application. When searching a very large drive, usable memory will no longer pose a restriction.

·Recently Used List: The 100 recently used search patterns can now be saved and selected from a dropdown list.

·Suggestion feature: If desired, all recently used search patterns matching the pattern you are currently typing can be displayed in a dropdown list and selected directly.

·Autocomplete feature: If desired, the pattern you are currently typing in the search input field can automatically be completed if it matches one of the recently used search patterns.

·Skip User account control warning: The User account control warning at the start of UltraSearch can now be skipped.

·Enhanced context menu: UltraSearch can now be started easily via the Windows Explorer context menu.

·Enhanced Time/Date values: The time and date values of the columns 'Last Change', 'Last Access', and 'Creation Date' can now be adjusted more precisely.

·Reworked menu structure: A new menu entry 'Search' containing all search-specific options has been added to the menu bar.

·New context menu entry 'Copy Full Path to Clipboard': Copying the full path of the selected search results to the clipboard by using the context menu of the search result list is now possible.

·New File version column: A new column 'File version' is now available. It displays the file version of EXE-files, DLL-files, SYS-files, MUI-files and many other file types.

·Bugfix: Fixed bugs in the Excel Export component.

·Bugfix: Numerous other bugfixes have been implemented.

Version 1.7.1 : (25 Oct 2012)

·Bugfix: The message 'You launched UltraSearch under restricted user account. Please restart UltraSearch with Administrator privileges' was erroneously displayed in some cases.

·Bugfix: Fixed error 'Cannot focus a disabled or invisible window' on UltraSearch startup.

·Bugfix: In some cases the drive list did not contain any items when UltraSearch was started via the option 'Launch at Windows Startup'.

·Bugfix: A few other bugfixes have been implemented.

Version 1.7 : (09 Oct 2012)

·A new Enumerator allowing UltraSearch to find NTFS hardlinks has been implemented. UltraSearch is now able to find all files on a hard drive. The search for NTFS hardlinks can be activated in the 'Options' menu.

·Regular expressions are now supported. Hint: to perform a search using a Regular expression, the search pattern must be enclosed with / (/Pattern/).

·A live update of the internal index has been realized: The index does not have to be refreshed when adding or deleting files on the system.

·The exclude filter has been replaced by the pattern manager of TreeSize Free V2.7. Exclude patterns can now be defined more precisely.

·A new option 'Launch at Windows startup' has been added: UltraSearch starts after Windows startup in the system tray.

·A new option 'Desktop Shortcut' has been added. The created shortcut allows you start UltraSearch without the UAC prompt (Windows Vista or later versions).

·A new option 'Context Menu Entry' has been added which can be used to create UltraSearch entries in the context menu of folders and drives, making it easy to search them.

·Search results can now be sorted according to specific criteria ('name', 'path', 'size' etc.) via the new menu item 'sort by'.

·A new column 'hardlinks' has been added which provides information regarding the number of hardlinks to a file.

·The new command line parameters / MINIMIZED and / TRAY can be used to start UltraSearch minimized in the taskbar or in the system tray.

·A new option 'Update Results' (F5) has been added.

·The progress bar now shows the progress while creating the index.

·Memory usage has been reduced, various search speed improvements have been implemented.

·When using the exclude filter the number of excluded files and folders is now displayed in the status bar.

·The search input field has been enlarged; it now adapts itself automatically to the size of the Ultra Search window.

·When searching for a full path the related drive will now be selected automatically.

·The user interface is now displayed properly on the scale of 125 % or 150 %.

·The Excel export function has been updated

·Setup: A new option has been added which can be used to create UltraSearch entries in the context menu of folders.

·Setup: A new option, 'Launch UltraSearch on Windows startup’ has been added to the setup.

·Bugfix: The portable version of UltraSearch no longer creates an empty folder in the user directory.

·Bugfix: The user now receives a message if UltraSearch was not started with administrator rights.

·Bugfix: An error in the CSV export function has been fixed (an incorrect list separator was used).

·Bugfix: Using a combined search (full path and filename) now displays the correct results.

·Bugfix: The flickering appearing when resizing the UltraSearch window has been reduced.

·Bugfix: The search input field is now focused on UltraSearch startup; a search can be entered immediately without an additional mouse click.

·Bugfix: The window position of UltraSearch is now saved when Ultra Search is closed via the icon in the system tray.

·Bugfix: In some cases the UAC started minimized. This error has been fixed.

·Bugfix: Numerous other bugfixes have been implemented.

Version 1.6.1 : (09 Jan 2012)

·Fixed a bug on system shutdown.

·Bugfix: Some context menu entries were missing after the installation.

·Bugfix: All context menu entries of UltraSearch will now be removed when uninstalling.

·Bugfix: A few minor bugfixes and improvements have been incorporated.

Version 1.6 : (25 Nov 2011)

·UltraSearch has been added to the Explorer context menu to search in the selected folder.

·With the new options "Include Folders" and "Include Files" you can now decide if you want to search for files, directories or both.

·It is now possible to toggle UltraSearch minimization via a customizable shortcut ("Options > UltraSearch Keyboard Shortcut").

·Improved search: If multiple drives are checked, results are shown immediately after the search of the first drive is done.

·Introduced new option "Autosort" to "View" menu to sort the results of a new search automatically by the previously selected sorting criteria.

·Added option to minimize UltraSearch when opening a folder in the search result list via double click.

·UltraSearch now supports Hotkey Ctrl+A to select all drives in the drivelist if it is focused.

·A new option in the drivelist context menu allows the user to check all drives in the list.

·Newly added drives can be checked by default via an option in the "Options" menu.

·Improved sorting results: Files and folders are no longer mixed up when sorting by name.

·The advertisement for TreeSize Professional is no longer shown if it is installed on the system.

·Fixed UAC dialog popup if you start UltraSearch when it is already running in system tray.

Version 1.5 : (18 Aug 2011)

·An option to show/hide the drives panel to the menu "View" has been added.

·It is now possible to minimize UltraSearch in the background as system tray icon.

·The search performance has been increased.

·UltraSearch now brings an already running instance to the foreground, if a second instance is started.

·A treatment for the special search pattern "*." has been implemented, so that files with no file extension are returned now.

·You can now press the "Shift" key while deleting folders or files to remove them directly from the drive instead of moving them to the recycle bin.

·If an USB flash drive is removed from the system, it is now also removed from the drive list.

·The hints have been improved.

·It is now possible to rename files or folders within the search result list.

·The number of files on the system which can be handled by UltraSearch has been increased to a value of 12.5 million.

·UltraSearch now refreshes its internal index automatically in the background from time to time.

·UltraSearch shows the number of selected files and folders in the status bar, if more than one file or folder is selected in the result list.

·Some of the hints are now shown in a tool tip manner.

·Added "Copy full Path to Clipboard" to context menu of the result list.

·Bugfix: In some cases the search in UltraSearch came to a state where UltraSearch did nothing but showed "Searching ...".

·Bugfix: After denying to delete an item on the result list, the item vanished from the view until the index was refreshed.

·Bugfix: In some cases the refreshing of the index using F5 led to missing results or to not showing any visual effects.

·Bugfix: Refreshing of the index multiple times doesn't lead to an increasing delay in displaying the results now.

·Bugfix: The unchecking of a drive if it is actually examined leads to a stop of the examination immediately now.

·Bugfix:UltraSearch had left a handle open to an external drive.

·Bugfix: In some cases the exclude filter seemed to be active although it was unchecked.

·Bugfix: For some system files in the column "Path" were shown their names.

Version 1.4.1 : (04 Oct 2010)

·Increased performance if the exclude filter is active.

·Increased performance when sorting by name.

·Bugfix: A few minor bugfixes and improvements have been incorporated.

Version 1.4 : (22 Sep 2010)

·Supports now search for folders, too.

·Added exclude filter including predefined filters.

·Introduced main menu bar (file, edit, search, view and help).

·It is now possible to determine the size unit used to display the file sizes.

·The result list can now be saved in HTML and RTF format by choosing the appropriate format in the "Save" dialog.

·Added support for disabling/enabling time values in date columns.

·Added columns attributes, creation date and file type.

·Removable drives are now supported (e.g. flash drives).

·Added check for update function.

·Introduced status bar to display main menu hint text on mouse over event.

·Bugfix: If a drive was disabled after a search was started it could happen that no search results were displayed.

·Bugfix: If the search result list consisted only of a few items and a double click was performed below the last item then the last selected entry was executed.

·Bugfix: Status bar changed position with drive list after application restart.

·Bugfix: In some cases an error occurred if a file of a recycle bin was deleted.

·Windows 2000 is no longer supported.

Version 1.3 Beta : (03 May 2010)

·Added search pattern to search for an exact match: Put the requested name in quotation marks.

·Added buttons: print, save and copy list to clipboard.

·Added button to perform a full refresh including the index.

·Added support for Hot keys: Ctrl+C, Ctrl+X and Del.

·Drag&Drop operations are now possible.

·Supports now passing of patterns via the command line.

·Bugfix: Result list does not reload totally after deleting a file/files anymore.

·Bugfix: The scroll position and sort order will remain also.

Version 1.2.1 Beta : (11 Feb 2010)

·UltraSearch passed the "Compatible with Windows 7" logo test.

·Improved speed for some search patterns.

·It is now possible to export the result list as text or CSV file.

·The path is now displayed without file name in the path column.

·Bugfix: Some search results were added twice to the result list.

·Bugfix: No default drive was selected for the first startup after the installation.

·Bugfix: Occasionally drive C:\ was added multiple times to the drive list.

·Bugfix: Sometimes files without information were shown.

·Bugfix: The Application could crash during the very first run.

·Bugfix: Improved error handling if the user has insufficient rights for accessing the MFT.

·Bugfix: Sort order of "Last Access Date" was incorrect.

·Bugfix: If the length of a path was larger than 255 characters an error message occurred.

·Bugfix: A few minor improvements have been incorporated.

Version 1.2 Beta : (25 Dec 2009)

·First official release.


F.A.Q. - Frequently Asked Questions

F.A.Q. - Frequently Asked Questions

·General

·Knowledge Base


General

F.A.Q - General

Navigation: F.A.Q. - Frequently Asked Questions >

F.A.Q - General
F: How can I search network drives?
A: UltraSearch accesses the MFT (Master File Table) of local NTFS partitions to find files and folders on your hard disk. This makes it impossible to search network drives. If you want to search a network, we recommend our disk space manager TreeSize. The TreeSize File Search is even more versatile than UltraSearch. It can access NTFS drives as well as FAT32 drives and it searches entire servers or networks. In addition, it offers several predefined searches, e.g. for temporary and duplicate files. Found files can be moved or deleted.
F: Why is my USB stick / my SD card not displayed in the drive list of UltraSearch ?
A: Your USB stick / SD card must be NTFS formatted in order to be searched by UltraSearch. Fat32 formatted or differently formatted drives cannot be searched. The file system of your drive can be displayed by right clicking on the drive and selecting 'Properties > General'. If your drive is not NTFS formatted, you can for example backup your files elsewhere, then format the drive to NTFS and restore the data from the backup. UltraSearch is now able to browse the drive.
Note: Please note that some digital cameras or TVs does not recognize NTFS formatted USB sticks or SD cards!
F: Searching for file content is very slow. Is it possible to speed up this process?
A: Searching for file content can be slow, because the whole content of a file has to be analyzed. In order to speed up this process, the content search should be further restricted by additional search criteria like 'file name' or 'file type'.
F: Why is the error message 'The path format is not supported.' shown?
A: UltraSearch does not support relative paths in the drive list. Specified paths must be clearly related to a drive, for example 'C:\Users\Default\Downloads' rather than 'Downloads'.
F: Why is the User Account Control shown when UltraSearch is started?
A: In order to find files and folders quickly on your hard drive, UltraSearch directly accesses the MFT (Master File Table) of local NTFS partitions. Administrator privileges are needed for this. As a consequence the User Account Control (UAC) is displayed. You can skip this message via 'Options > Skip User Account Control Warning'.


Knowledge Base

Navigation: F.A.Q. - Frequently Asked Questions >

Knowledge Base

Haven't found what you are looking for? Try searching in our online Knowledge Base.
Press "search" to open the Knowledge Base in your default web browser.

Please note: An Internet connection is required, JavaScript needs to be enabled in your web browser.


Menu

UltraSearch - Menu

UltraSearch - Menu

File

Save List...

Saves the results of the latest search.

Copy List to Clipboard

Copies the search results to the clipboard. If more than one item is selected, it copies the selected items only.

Print List

Prints the current search results.

Print Setup...

Configures the printer and its settings.

Exit

Exits the program or minimizes it to the system tray icon (depending on settings).

Edit

Copy

Copies the selected items to the clipboard.

Cut

Cuts the selected items and copies them to the clipboard.

Select All

Selects all items in the result list.

Invert Selection

Inverts the current selection in the result list.

View

Values in Bytes

All sizes are shown in Bytes.

Values in KB

All sizes are shown in Kilobytes.

Values in MB

All sizes are shown in Megabytes.

Values in GB

All sizes are shown in Gigabytes.

Automatic Unit

Automatically chooses the appropriate unit.

Date/Time Format

Sets the date/time format used for date columns.

Font Size

Sets the size of the font in the result list.

Language

Changes the language of the user interface.

Options Toolbar

Displays the options toolbar.

File Preview

Activates the file preview beside the result list.

Search

Refresh Results

Refreshes the search results.

Rescan MFT

Refreshes the file system data from the MFT used for searching.

Include Files

Indicates, if files will be included in the search results.

Include Folders

Indicates, if folders will be included in the search results.

Exclude Filter

Opens the Exclude Filter dialog.

Include subfolders

If enabled, all subfolders of the selected search path will be searched.

Use RegEx

Treats the search pattern as a regular expression.

Ignore Umlauts/Accents

Handles umlauts and accents insensitive.

Options

Configure File Groups...

Opens the File Groups dialog.

Search Field

Specifies the behaviour of the search field:

Save Recently Used Patterns: If enabled, the last used search patterns will be memorized. You can select these patterns by using the drop-down list of the search field.

Note: A search pattern is saved once the user presses the enter key or clicks outside of the search field.

Suggest Patterns: If enabled, a drop-down list is displayed while entering a search pattern, which displays suitable patterns based on previous searches (Note: 'Save Recently Used Patterns' must be activated in order to use this option).

Explorer Context Menu

Offers several enhancements for the Windows Explorer context menu:

Start UltraSearch: If activated, UltraSearch can be started from the Windows Explorer context menu.

Search with UltraSearch: If activated, UltraSearch can be started from the Windows Explorer context menu and automatically searches the current folder.

Skip User Account Control Warning

Activate this option to skip the user account control warning at UltraSearch startup.

Launch at Windows Startup

Once activated, UltraSearch will start in the system tray on Windows startup.

Minimize to a System Tray Icon

If this option is enabled, UltraSearch will minimize to a system tray icon once closed. Click on the icon to open UltraSearch again.

Minimize on Double Click

Minimizes UltraSearch when opening a file/folder in the search result list via double click.

Auto check New Drives

Automatically activates newly added drives in the drives list.

UltraSearch Keyboard Shortcut

Selects a Keyboard Shortcut to toggle UltraSearch minimization.

Include File System Changes

If this option is enabled, file system changes will automatically be recognized when a new search is invoked.

Sort by

Name

Sorts the search results by 'Name'.

Path

Sorts the search results by 'Path'.

Size

Sorts the search results by 'Size'.

Last modified

Sorts the search results by 'Last modified' date.

Last accessed

Sorts the search results by 'Last accessed' date.

Creation Date

Sorts the search results by 'Creation Date'.

Type

Sorts the search results by 'Type'.

Attributes

Sorts the search results by 'Attributes'.

Hardlinks

Sorts the search results by 'Hardlinks'. (See: Notes on NTFS)

File Version

Sorts the search results by 'File Version'.

Ascending

Sorts the search results in ascending order.

Descending

Sorts the search results in descending order.

Always Sort Results

Applies the current sorting order for each new search (slower).

Help

Help

Opens the UltraSearch help file.

Check for Update...

Checks if a newer version of UltraSearch is available.

About...

Provides information about UltraSearch.

Advanced Search

Learn more about TreeSize

Opens the TreeSize web site with additional information about the product TreeSize.

Search network drives with TreeSize

Opens the TreeSize File Search web site with additional information about searching network drives with TreeSize.

Search for file owners with TreeSize

Opens the TreeSize Custom File Search web site with additional information about searching for file owners with TreeSize.

Search for duplicate files with TreeSize

Opens the TreeSize Duplicate Search web site with additional information about searching for duplicate files with TreeSize.

Download Free Trial of TreeSize

Opens the TreeSize download web site.


Drive List

Drive List

Drives and Paths to search

The expandable drive overview enables you to define the drives and paths to search in.

In its non-expanded state, it shows all searchable drives and paths that are selected for the current search. Additional paths can be browsed for, by using the plus symbol. Paths, which are displayed here, can easily edited with a single click, which allows you to edit the search paths quickly without expanding the drive list.

When expanded, the panel shows a list of all available drives, as well as the previously selected search paths, in a drop-down menu. Use the check boxes in front of each drive to select which drives or folders should be searched by UltraSearch. Each path can be pinned to the drive list by clicking on the Pin column. Thus, the search path will be permanently stored in the drive list.

You can add additional paths from local NTFS drives using the buttons below the list. The button on the left enables you to type in a path, the button on the right opens a folder browser dialog.

Tip: For searching network drives or domains, we recommend the usage of TreeSize. A free demo version can be downloaded here.


File Search

File Search

In order to start a search, a search pattern has to be entered. File and folder names can be searched as well as specific file types or files with a specific file content.

1. Search for file and folder names:

The search field allows you to search for specific file or folder names:

·The wildcards '*' or '?' will be recognized.

·For exact matching, double quotes (") can be used.

· Regular Expressions are supported.

·Multiple search patterns are allowed. They have to be separated with semicolons (;).

·Previous search patterns can be selected from the drop-down list if 'Options > Search Field > Save Recently Used Patterns' is activated.

·If 'Options > Search Field > Suggest Patterns' is additionally activated, the drop-down list suggests suitable patterns based on previous searches while entering a search pattern.

The following table contains some examples:

readme oder *readme* | Search for file names which contain the word 'readme' in its name. Examples: readme.txt, readmeV2.docx, 1_readmeV2.txt
readme* | Search for file names which begin with the word 'readme'. Examples: readme.txt, readmeV2.docx.
*readme | Search for file names which end with the word 'readme'. Examples: readme.txt, V2_readme.txt
"readme.txt" | Search for files with the name 'readme.txt'. Examples: readme.txt
rea?me | Search for file names which begin with 'rea' and end with 'me' with exactly one character in between. Examples: readme.txt, reasme.txt, rea1me.txt
readme; prog; | Search for file names which contain the word 'readme' or 'prog'. Examples: readme.txt, readmeV2.log, programming.xlsx
"readme.txt"; *.log | Search for files with the name 'readme.txt' or for file names which contain the word 'logfile'. Examples: readme.txt, logfile.log, mylogfile.docx

Examples and further information about regular expressions can be found here.

If the option 'Include folders' is activated, UltraSearch also searches for folders which match the entered search pattern.

2. Search for file types and file groups

The file type selection can be used to limit the search to specific file types or file groups in addition to the entered search pattern. The file groups can be selected from the drop-down list or entered manually.

·The file groups which are available in the drop-down list can be configured via 'Options > Configure File Groups...'.

·Multiple file types and file groups can be entered. They have to be separated by semicolons (;).

·The following syntax is allowed for file types: *.txt or .txt or txt

The following table contains some examples:

Selection: Text Files | Search for text files whose file name matches the pattern from the search field. Examples: readme.txt, logfile.log, readme.nfo
Audio Files; Video Files; | Search for audio and video files whose file name matches the pattern from the search field. Examples: film.mkv, audio.mp3
txt | Search for files with the file extension 'txt' whose file name matches the pattern from the search field. Examples: readme.txt, text.txt
txt; docx; | Search for files with the file extension 'txt' or 'docx' whose file name matches the pattern from the search field. Examples: readme.txt, readme.docx
Text Dateien; docx; xlsx; | Search for text files or files with the file extension 'docx' or 'xlsx' whose file name matches the pattern from the search field. Examples: readme.txt, logfile.log, readme.docx, rec.xlsx

3. Search for file content

In addition to the search for file names or file types, the file content search allows you to search for files that have a specific content. UltraSearch can analyze the textual content of a file and look for a given set of search terms. If the search terms are found inside of a file, the file will be displayed in the search result list. This is possible for non-plain text file formats as well, such as PDF, Microsoft Excel or Microsoft Word.

Note: Searching for file content can be slow, because the whole content of a file has to be analyzed. It is strongly recommended to combine the file content search with other search criteria to speed up the search.

Plain text and IFilter

UltraSearch is able to search plain text files very quickly, by traversing them directly on file system level and matching their content to the given search term. All commonly used file encodings, such as ASCII, Unicode, or UTF-8 are supported.

For more complex file types, such as Microsoft Word, Excel or PowerPoint, UltraSearch uses the IFilter interface, which is provided by the operating system. Any application can register their own filter handler for a specific file type. Some handlers are already shipped alongside with Windows. An example for such a filter handler is the one that handles document types and allows to read the content of files that are saved in the .docx format.

Other file types, such as PDF, can be read by filter handlers that are installed by PDF reader applications. They are registered during the installation of the PDF reader application and available for UltraSearch automatically.

Case sensitivity

Differences in capital or smaller case letters will be disregarded for all search types (searching for file names, file types or file content). The search is 'case insensitive'. UltraSearch will use the code page associated with the currently specified locale.


File Groups

File Groups

The file groups which are available in the file group selection can be configured via 'Options > Configure File Groups...'.

Adding a new group

1.Enter the name of the group (e.g. 'Text files') in the 'Group definitions' text field on top of the page.

2.Click 'Add Group'.

3.Click the text field in the 'Associated file types' area and enter the desired file extensions (e.g. '*.txt').

4.Click 'Add Pattern'.

5.Repeat the step 3 and 4 until you have added all of the desired file extensions.

6.Click 'Ok' to save the settings.

Add/remove/edit file extensions of an existing group

1.Click the desired file extensions group in the 'Group definitions' on top of the page.

2.Add new file extensions like described in steps 4 and 5 above
or
use the 'Remove' button on the right to remove an existing file extension from the list
or
right-click on an existing file extension and click "Edit Pattern" to change the pattern of an item.

3.Click 'Ok' to save the settings.

Edit caption and description of an exiting group

Simply right-click on the desired group and select 'Edit Caption' or 'Edit Description'.

Export/import list of file extensions

Existing file groups can be exported to a Text, CSV or XML file by right-clicking on the 'Associated file types' listing and selecting 'Export'. You can import a definition into an existing group in the same way.


Exclude Filter

Exclude Filter

UltraSearch lets you specify folders, files, or even file types to be ignored in a search. A filter has to be in the same format as a search pattern.

The Exclude Filter dialog can be opened via 'Search > Exclude Filter...' in the menu bar or by using the corresponding entry in the Options Toolbar.

How to define a filter

To define a new filter, please follow these steps:

1.Click the 'Add pattern' button. A entry will be created in the filters list for the new filter.

2.Now you can define an exclude filter in the 'Pattern' column. You can either use simple wildcard pattern such as '*.exe', regular expression patterns such as '.+\.exe$' or patterns that match the whole name like 'notepad.exe'. If, for example, an exclude filter for the pattern '*.exe' is set, UltraSearch will not show any files with the extension '.exe'. Please ensure that the correct 'Type' for your exclude pattern is selected in the identically named column.

3.The 'Match Against' column is used to specify the element/attribute against which the pattern is compared. Patterns can either be matched against the file or folder names, (full) paths, name of the direct parent folder or name of any parent folder. With the full path filter you can exclude complete directory branches matching a certain pattern (e.g. "*\Program Files*"). 'File or Folder Name' should be used when you intent to include or exclude certain file extensions.

Wildcards allowed in Wildcard patterns:

* | Replaces none or arbitrarily many alphanumeric characters.
? | Replaces exactly one alphanumeric character.

Not only names of files and folders are allowed, the patterns may also contain parts of directories. Multiple patterns can be used by separating them using semicolons.To force the exact match (instead of a substring match) of a pattern, please select 'Whole Name' in the Type column for this pattern. Regular expressions can also be used as patterns by selecting 'RegEx' in the 'Type' column.

The following table shows possible patterns:

Pattern | Match Against | Type | Result
*.doc | File or Folder Name | Wildcard | Searches for all files with the extension 'doc'.
*\Windows\System32\*.exe | Full Path | Wildcard | Searches for all applications in the path 'Windows\System32'.
"Neues Textdokument.txt" | File or Folder Name | Whole Name | Searches for all files named 'New Text Document.txt'.
C:\\([a-z]*\\){2,4}[^\\]*\.[^\\]*$ | Full Path | RegEx | Searches for all files on drive C: with a folder depth from at least 2 and at most 4.

Choose a defined exclude filter and click on 'Preview...' to open an explorer view, which displays the Files and Folders that are excluded by this filter. Excluded folders and files are displayed in red while green coloured ones are still considered in the search.

The 'Add Default Filters' button creates predefined exclude filters for specific system folders (like the recycle bin).


Notes on NTFS

Notes on NTFS

Hardlinks

In a Windows environment a hardlink is a reference or pointer to physical data on a NTFS storage volume. All named files are hardlinks. The name associated with the file is simply a label that refers the operating system to the actual data. On NTFS volumes more than one name can be associated with the same data. Though called by different names, any changes made will affect the actual data, regardless of how the file is called at a later time. Hardlinks can only refer to data that exists on the same file system. The data is accessible as long as at least one link that points to it exists. When the last link is removed, the space is considered free. Please note that all hardlinks pointing to the same file also share the same security description (access permissions).

If more than one hardlink points to a file's data, the space allocated by these files is just one time the file size (not including the space of the file master table), no matter how many hardlinks exists. UltraSearch is able to detect the number of hardlinks pointing to one file data. The number of hardlinks which points to one file data is displayed in the Hardlinks column.


Regular Expressions

Regular Expressions

Regular expressions describe patterns in strings and can be used i.a. to determine whether a given pattern occurs in a text or not. In UltraSearch regular expressions can be used to find specific files and / or folders that match the criteria specified by regular expressions

The following table shows some examples:

Expression | Syntax | Description | Example
Any character | . | Matches any single character except a line break. | a.o matches "aro" in "around" and "abo" in "about" but not "acro" in "across".
Zero or more | * | Matches zero or more occurrences of the preceding expression, and makes all possible matches. | a*b matches "b" in "bat" and "ab" in "about". e.*e matches the word "enterprise".
One or more | + | Matches at least one occurrence of the preceding expression. | ac+ matches words that contain the letter "a" and at least one instance of "c", such as "race", and "ace". a.+s matches the word "access".
Beginning of word | < | Matches only when a word starts at this point in the text. | <in matches words such as "inside" and "into" that begin with the letters "in".
End of word | > | Matches only when a word ends at this point in the text. | ss> matches words such as "across" and "loss" that end with the letters "ss".
Any one character in the set | [] | Matches any one of the characters in the []. To specify a range of characters, list the starting and ending characters separated by a dash (-), as in [a-z]. | be[n-t] matches "bet" in "between", "ben" in "beneath", and "bes" in "beside" but not "bel" in "below".
Any one character not in the set | [^...] | Matches any character that is not in the set of characters that follows the ^. | be[^n-t] matches "bef" in "before", "beh" in "behind", and "bel" in "below", but not "ben" in "beneath".
Or | | | Matches either the expression before or the one after the OR symbol (|). Mostly used in a group. | (sponge|mud) matches "sponge bath" and "mud bath.
Tagged expression (or backreference) | \ | Matches the character that follows the backslash (\) as a literal. This lets you find the characters that are used in regular expression notation, such as { and ^. | \^ searches for the ^ character.
Markierter Ausdruck | {} | Matches text that is tagged with the enclosed expression. | {does}n't identifies the text that precedes the replacement in the replace string \1 not to change every occurrence of doesn't to does not.
Repeat n times | ^n | Matches n occurrences of the preceding expression. | [0-9]^4 matches any 4-digit sequence.
Grouping | () | Lets you group a set of expressions together. If you want to search for two different expressions in a single search, you can use the Grouping expression to combine them. | If you want to search for [a-z][1-3] or [0-9][a-z], you would combine them: ([a-z][1-3])|([0-9][a-z]).

Further examples:

[0-9] or /\d | Find all files/folders with at least one digit in its name.
a|b | Find all files/folders containing "a" or "b" in their name.
(?=.*a)(?=.*b) | Find all files/folders containing at least one "a" character and one "b" character.
((?=.*help)|(?=.*online))(?=.*readme) | Find all files/folders containing the words 'help' and 'readme' or 'online' and 'readme'.
[^(A-Za-z)] | Find all files/folders containing at least one other symbol than a character in their name.
^E[0-9]{7}$ | Find all files/folders which start with an "E" followed by exactly 7 digits.
C:\\Windows\\[^\\]*\.[^\\]*$ | Find all files/folders whose parent folder is "C:\Windows".
[A-Za-z]:\\([^\\]+\\){2,4}[^\\]+$ | Find all files/folders with a folder depth of at least 2 and at most 4.
[^\x00-\x7F] | Find all files/folders with invalid ASCII characters.
[^\P{C}] | Find all files/folders with Unicode characters which cannot be printed.
[\xA0] | Find all file/Folder names that contain the non-breakable space character (Unicode NOBR, U+00A0) instead of a normal space character.
[~,\",#,%,&,\*,\:,<,>,\?,\/,\\,{,|,}] | Find all files and folders, that contain characters in their name which are invalid on SharePoint servers.

Further information and additional examples can be found here.

A description of all special characters that can be used with regular expression can be found here.

For further help in forming regular expressions following tools can be used:

http://gskinner.com/RegExr/ (online)

http://regexpal.com/ (online)

http://sourceforge.net/projects/regexpeditor/ (download)

http://sourceforge.net/projects/regextester/ (download)

http://sourceforge.net/projects/regaxe/ (download)


Command Line Options

Command Line Options

Command Line Options

UltraSearch supports command line parameters which can be used to start UltraSearch with predefined search parameters. Multiple parameters are separated by blanks.

Search parameters (paths or file names) which already contain blanks have to be surrounded with double quotes (").

Die general syntax for command line parameters are as follows:

UltraSearch.exe SearchPath(s) FileName(s) FileType(s)

Examples:

ultrasearch.exe "C:\Windows" "readme.txt" | Starts UltraSearch and searches for all files whose name contain 'readme.txt' in the directory branch 'C:\Windows'.
ultrasearch.exe "C:\Windows" """readme.txt""" | Starts UltraSearch and searches for all files with the exact name 'readme.txt' in the directory branch 'C:\Windows'.
ultrasearch.exe "C:\Windows" "*.txt" | Starts UltraSearch and searches for all files with the file extension '.txt' in the directory branch 'C:\Windows'.
ultrasearch.exe "C:\Windows\readme.txt" | Starts UltraSearch and searches for all files with the name 'readme.txt' in the folder 'C:\Windows'.
ultrasearch.exe "C:\Windows" "C:\Program Files" "readme.txt" "logfile.log" | Starts UltraSearch and searches for all files whose name contain 'readme.txt' or 'logfile.log' in the directory branches 'C:\Windows' and 'C:\Program Files'.
ultrasearch.exe /minimized | Starts UltraSearch minimized in the WIndows task bar.
ultrasearch.exe /maximized | Starts UltraSearch as maximized Window.
ultrasearch.exe /tray | Starts UltraSearch minimized in the Windows system tray.


Copyright & Contact

Copyright & Contact

Copyright © 2018 Joachim Marder e.K.

JAM Software GmbH
Am Wissenschaftspark 26
54296 Trier

Germany

FAX: | +49-651-145653-29
WWW: | https://www.jam-software.com
Support: | https://www.jam-software.com/customers/contact.php
Email: | ultrasearch@jam-software.com
Commercial register number: | HRB: 4920 (AG Wittlich)
VAT ID No.: | DE234825349
Managing Director: | Joachim Marder